-- Synsyntax - Zul'jin (US)
-- Justin M. Wray
-- justinwray.com

-- Fork of say-cc by:
-- Moylen - Well of Eternity (EU)
-- moylen at moylen.eu

local addonTitle, addonTable = ...

-- vars : SayStunsPrefs

local SayStuns      = CreateFrame("Frame")
SayStuns.playername = UnitName("player")
SayStuns.VERSION = GetAddOnMetadata("say-stuns", "Version")
SayStuns.NAME   = 'SayStuns'
SayStuns.color = {
    WHITE  = "|cffffffff";
    RED    = "|cffff6666";
    GREEN  = "|cff66ff66";
    BLUE   = "|cff9999ff";
    YELLOW = "|cffffff66";
    RESET   = "|r";
}
SayStuns.NAMEC  = SayStuns.color["RED"] .. "Say" .. SayStuns.color["GREEN"] .. "C" .. SayStuns.color["YELLOW"] .. "C" .. SayStuns.color["RESET"]

-- by id, msg on applied, msg on removed; default.
local saystuns_spells = {}
saystuns_spells[1766]   = { "KICK",  "I've been kicked (holy lock)", "Holy lock gone"}
saystuns_spells[408]   = { "STUN",  "I've been stuned", "Stun gone"}
saystuns_spells[30832]   = { "STUN",  "I've been stuned", "Stun gone"}
saystuns_spells[1833]   = { "STUN",  "I've been stuned", "Stun gone"}
saystuns_spells[30986]   = { "STUN",  "I've been stuned", "Stun gone"}
saystuns_spells[133002]   = { "STUN",  "I've been stuned", "Stun gone"}
saystuns_spells[14902]   = { "STUN",  "I've been stuned", "Stun gone"}
saystuns_spells[138412]   = { "STUN",  "I've been stuned", "Stun gone"}
saystuns_spells[31819]   = { "STUN",  "I've been stuned", "Stun gone"}
saystuns_spells[5211]   = { "STUN",  "I've been stuned", "Stun gone"}
saystuns_spells[853]   = { "STUN",  "I've been stuned", "Stun gone"}
saystuns_spells[54132]   = { "STUN",  "I've been stuned", "Stun gone"}
saystuns_spells[19577]   = { "STUN",  "I've been intimidated", "Intimidation finished"}
saystuns_spells[99]   = { "INCAP",  "I've been incapacitated", "Incapacitate over"}
saystuns_spells[12540]   = { "INCAP",  "I've been incapacitated", "Incapacitation gone"}
saystuns_spells[33786]   = { "INCAP",  "I've been cycloned", "Cyclone gover"}
saystuns_spells[88075]   = { "INCAP",  "I'm dazed from a typhoon", "Typhoon over"}
saystuns_spells[6552]   = { "INCAP",  "I've been pummeled", "Pummel over"}
saystuns_spells[6770]   = { "SAP",  "I've been sapped", "Sap gone"}
saystuns_spells[2094]   = { "SAP",  "I am blind!",      "I can see again!"}
saystuns_spells[115078] = { "SAP",  "I am paralysed",   "I can move again!"}
saystuns_spells[51514]  = { "POLY", "I've been hexed!", "Un-frogged!"}
-- polymorphs
saystuns_spells[118]    = { "POLY",  "I'm polymorphed",  "Poly ended!" }
saystuns_spells[61305]  = { "POLY",  "I'm polymorphed",  "Poly ended!" }
saystuns_spells[28272]  = { "POLY",  "I'm polymorphed",  "Poly ended!" }
saystuns_spells[61721]  = { "POLY",  "I'm polymorphed",  "Poly ended!" }
saystuns_spells[61780]  = { "POLY",  "I'm polymorphed",  "Poly ended!" }
saystuns_spells[28271]  = { "POLY",  "I'm polymorphed",  "Poly ended!" }
-- Fear
saystuns_spells[5782]   = { "FEAR",  "I'm feared!",      "No more fear!" }
saystuns_spells[56244]  = { "FEAR",  "I'm feared!",      "No more fear!" }
saystuns_spells[118699] = { "FEAR",  "I'm feared!",      "No more fear!" }
-- Psychic scream
saystuns_spells[8122]   = { "FEAR",  "I'm feared!",      "No more fear!" }
-- intimidating shout
saystuns_spells[5246]   = { "FEAR",  "I'm feared!",      "No more fear!" }
-- turn evil
saystuns_spells[10326]  = { "FEAR",  "I'm feared!",      "No more fear!" }
saystuns_spells[145067] = { "FEAR",  "I'm feared!",      "No more fear!" }
-- Silences
saystuns_spells[15487]  = { "SILENCE", "I'm silenced!",   "I can cast again!" }
saystuns_spells[1330]   = { "SILENCE", "I'm garroted!",   "I can cast again!" }
saystuns_spells[147362] = { "SILENCE", "I've been countered!", "I can cast again!" }
saystuns_spells[2139]   = { "SILENCE", "I'm counterspelled", "I can cast again!" }
saystuns_spells[165282]   = { "SILENCE", "I'm counterspelled", "I can cast again!" }
saystuns_spells[129888]   = { "SILENCE", "I'm counterspelled", "I can cast again!" }
saystuns_spells[78675]   = { "SILENCE", "I'm counterspelled", "I can cast again!" }
saystuns_spells[2139]   = { "SILENCE", "I'm counterspelled", "I can cast again!" }
saystuns_spells[41084]   = { "SILENCE", "I've been silence shot", "I can cast again!" }
saystuns_spells[34490]   = { "SILENCE", "I've been silence shot", "I can cast again!" }
saystuns_spells[57994]   = { "SILENCE", "I've been silenced", "I can cast again!" }
saystuns_spells[19647]   = { "SILENCE", "I've been silenced", "I can cast again!" }
-- Sleeps
saystuns_spells[19386]   = { "SLEEP", "I've been put to sleep", "I can cast again!" }

-- Rebuke
saystuns_spells[96231] = { "SILENCE", "I've been rebuked!", "I can cast again!" }
saystuns_spells[134008] = { "SILENCE", "I've been rebuked!", "I can cast again!" }
-- Asphixiate
saystuns_spells[108194] = { "SILENCE", "Asphyxiated!", "I can cast again!" }
saystuns_spells[47476]  = { "SILENCE", "Strangulated!", "I can cast again!" }
saystuns_spells[47528]  = { "SILENCE", "My mind is frozen", "I can cast again!" }
-- Dark Simulacrum -- pay attention to this!
saystuns_spells[77606] = { "SIMULACRUM", "DARK SIMULACRUM ON ME!", "Dark Simulacrum faded!" }

-- /run SayStunsPrefs.prefs["DEBUG"] = 1
-- /run SayStunsPrefs.prefs["DEBUG"] = nil

--
local function saystuns_onevent(_,real_event,arg1,event, _,_,sourceName, _,_,_,destName, _,_,spellId)
	if real_event == "ADDON_LOADED" then
		if arg1 == addonTitle then
			if SayStunsPrefs == nil or SayStunsPrefs.version ~= SayStuns.VERSION then
				if SayStunsPrefs == nil then
					DEFAULT_CHAT_FRAME:AddMessage(SayStuns.NAMEC..": Default preferences set.")
					SayStunsPrefs = {
						version = SayStuns.VERSION;
						spells  = saystuns_spells;
						prefs   = {
							KICK    = 1;
							STUN    = 1;
							INCAP   = 1;
							SLEEP	= 1;
							SAP     = 1;
							FEAR    = 1;
							POLY    = 1;
							FEAR    = 1;
							SILENCE = 1;
							DEBUG   = 0;
							SIMULACRUM = 1;
							CHANNEL= "SAY";
						}
					}
				else
					DEFAULT_CHAT_FRAME:AddMessage(SayStuns.NAMEC..": New version detected. Preferences upgraded.")
					SayStunsPrefs.version = SayStuns.VERSION
					SayStunsPrefs.spells  = saystuns_spells
				end
			end
			if SayStunsPrefs.prefs["DEBUG"] == 1 then
				DEFAULT_CHAT_FRAME:AddMessage(SayStuns.NAMEC..": Debugging is ENABLED. to disable: "..SayStuns.color["RED"].."/run SayStunsPrefs.prefs[\"DEBUG\"] = nil|r")
			end
		end
	elseif real_event == "VARIABLES_LOADED" then
		-- addonTable:SetupConfigFrame()
		if SayStunsPrefs.prefs["DEBUG"] == 1 then
			DEFAULT_CHAT_FRAME:AddMessage(SayStuns.NAMEC.." XXX Time to configure frame")
		end
	elseif real_event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if (destName ~= SayStuns.playername) then return end
		if not saystuns_spells[spellId] then
			if SayStunsPrefs.prefs["DEBUG"] == 1 then
				DEFAULT_CHAT_FRAME:AddMessage(SayStuns.NAMEC.." DEBUG=1: UNKNOWN SPELL " .. spellId .. " event " .. event)
			end
			return
		end
		if not SayStunsPrefs.prefs["CHANNEL"] then SayStunsPrefs.prefs["CHANNEL"] = "SAY" end
		if (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_CAST_SUCCESS") then
			if SayStunsPrefs.prefs["DEBUG"] == 1 then SendChatMessage(SayStuns.NAMEC.."Action Caught: " .. spellId, SayStunsPrefs.prefs["CHANNEL"]) end
			if SayStunsPrefs and SayStunsPrefs.prefs[ saystuns_spells[spellId][1] ] then
				SendChatMessage("{rt8} " .. saystuns_spells[spellId][2] .. " {rt8}", SayStunsPrefs.prefs["CHANNEL"])
				DEFAULT_CHAT_FRAME:AddMessage(SayStuns.NAMEC.." " .. saystuns_spells[spellId][1] - .. " " .. saystuns_spells[spellId][1] .. " by: " .. (sourceName or "(unknown)"))
			end
			return
		elseif (event == "SPELL_AURA_BROKEN" or event == "SPELL_AURA_BROKEN_SPELL" or event == "SPELL_AURA_REMOVED") then
			if SayStunsPrefs and SayStunsPrefs.prefs[ saystuns_spells[spellId][1] ] then
				SendChatMessage("{rt7} " .. saystuns_spells[spellId][3] .. " {rt7}", SayStunsPrefs.prefs["CHANNEL"])
			end
			return
		else
			if SayStunsPrefs.prefs["DEBUG"] == 1 then
				DEFAULT_CHAT_FRAME:AddMessage(SayStuns.NAMEC.." DEBUG=1: NEITHER APPLIED, REFRESH, BROKEN, BROKEN_SPELL nor REMOVED " .. spellId .. " event " .. event)
			end
			return
		end
	end
end

SayStuns:SetScript("OnEvent",saystuns_onevent)
SayStuns:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
SayStuns:RegisterEvent("VARIABLES_LOADED")
SayStuns:RegisterEvent("ADDON_LOADED")
DEFAULT_CHAT_FRAME:AddMessage(SayStuns.NAMEC.." v"..SayStuns.VERSION.." loaded.|r")